package com.patzn.cloud.service.lims.hmhj.service.impl;

import com.baomidou.mybatisplus.mapper.Condition;
import com.baomidou.mybatisplus.toolkit.CollectionUtils;
import com.patzn.cloud.commons.controller.Account;
import com.patzn.cloud.service.hmhj.entity.ContractSampleRecord;
import com.patzn.cloud.service.hmhj.enums.ContractSampleStatusEnum;
import com.patzn.cloud.service.lims.hmhj.mapper.ContractSampleRecordMapper;
import com.patzn.cloud.service.lims.hmhj.service.IContractSampleRecordService;
import com.patzn.cloud.commons.service.impl.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.baomidou.mybatisplus.plugins.Page;

import java.util.ArrayList;
import java.util.List;

/**
 * 合同样品操作日志 服务实现类
 *
 * @author wwd
 * @since 2021-02-05
 */
@Service
public class ContractSampleRecordServiceImpl extends BaseServiceImpl<ContractSampleRecordMapper, ContractSampleRecord> implements IContractSampleRecordService {

    @Override
    public Page<ContractSampleRecord> page(Page<ContractSampleRecord> page, ContractSampleRecord contractSampleRecord) {
        Wrapper wrapper = new EntityWrapper<>(contractSampleRecord);

        return this.page(page, wrapper);
    }

    @Override
    public boolean removeByIds(List<Long> ids) {
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public void record(Long[] ids, ContractSampleStatusEnum from, ContractSampleStatusEnum to, int type, String reason, Account account) {
        List<ContractSampleRecord> saveRecordList = new ArrayList<>();
        for (Long id:ids) {
            ContractSampleRecord record = new ContractSampleRecord();
            record.setContractSampleId(id);
            record.setOperator(account.getUserName());
            record.setOperatorId(account.getUserId());
            record.setOrigin(from.getDisplay());
            record.setTarget(to.getDisplay());
            record.setType(type);
            record.setRemark(reason);
            saveRecordList.add(record);
        }
        if (CollectionUtils.isNotEmpty(saveRecordList)){
            saveBatch(saveRecordList);
        }
    }
}
